import { Effect, Flow, AnyFunc, FlowDataInfer } from "./main";
export interface Cancellable {
}
export interface RetryOptions {
    max: number;
    delay?: number;
}
export declare function retry<T extends AnyFunc>(max: number, fn: T, ...args: Parameters<T>): Effect;
export declare function retry<T extends AnyFunc>(options: RetryOptions, fn: T, ...args: Parameters<T>): Effect;
export declare function remove(key: string | AnyFunc | (string | AnyFunc)[]): Effect;
export declare function debounce(ms: number): Effect;
export declare function block(): Effect;
export declare function block(value: boolean): Effect;
export declare function block(until: Date): Effect;
export declare function block(ms: number): Effect;
export declare function cancel(): Effect;
export declare function cancel(cancellable: Cancellable): Effect;
export declare function cancel(key: string): Effect;
export declare function cancel(flow: AnyFunc): Effect;
export declare function expiry(date: Date): Effect;
export declare function expiry(ms: number): Effect;
export declare function stale(type: "when", done: Promise<any>): Effect;
export declare function stale(type: "when", date: Date): Effect;
export declare function stale(type: "when", timeout: number): Effect;
export declare function stale(type: "when", event: string | string[], check?: (payload: any) => boolean): Effect;
export declare function stale(type: "flow", key: string | string[], check?: (flow: Flow) => boolean): Effect;
export declare function stale<T extends AnyFunc>(type: "flow", flow: T, check?: (flow: Flow<T>) => boolean): Effect;
export declare function stale(type: "flow", flow: AnyFunc[], check?: (flow: Flow) => boolean): Effect;
export declare function partial(data: any, wait?: boolean): Effect;
export declare function on<T extends AnyFunc>(event: string | string[]): Effect;
export declare function on<T extends AnyFunc>(event: string | string[], flow: T, ...args: Parameters<T>): Effect;
export declare function emit(event: string, payload?: any): Effect;
export declare function all(targets: {
    [key: string]: Effect;
}): Effect;
export declare function all(targets: Effect[]): Effect;
export declare function race(targets: {
    [key: string]: Effect;
}): Effect;
export declare function race(targets: Effect[]): Effect;
export declare function call<T extends AnyFunc>(fn: T, ...args: Parameters<T>): Effect;
export declare function start<T extends AnyFunc>(flow: T, ...args: Parameters<T>): Effect;
export declare function start<T extends AnyFunc>(key: [string, ...Parameters<T>], flow: T): Effect;
export declare function start<T extends AnyFunc>(key: string, flow: T, ...args: Parameters<T>): Effect;
export declare function run<T extends AnyFunc>(flow: T, ...args: Parameters<T>): Effect;
export declare function run<T extends AnyFunc>(key: [string, ...Parameters<T>], flow: T): Effect;
export declare function run<T extends AnyFunc>(key: string, flow: T, ...args: Parameters<T>): Effect;
export declare function restart<T extends AnyFunc>(flow: T, ...args: Parameters<T>): Effect;
export declare function restart<T extends AnyFunc>(key: [string, ...Parameters<T>], flow: T): Effect;
export declare function restart<T extends AnyFunc>(key: string, flow: T, ...args: Parameters<T>): Effect;
export declare function fork<T extends AnyFunc>(flow: AnyFunc, ...args: Parameters<T>): Effect;
export declare function spawn<T extends AnyFunc>(flow: T, ...args: Parameters<T>): Effect;
export declare function extra(value?: Record<string, any>): Effect;
export declare function data(key: string, value: ((prev: any) => any) | any): Effect;
export declare function data<T extends AnyFunc>(flow: T, value: ((prev: FlowDataInfer<T>) => FlowDataInfer<T>) | FlowDataInfer<T>): Effect;
export declare function data<T = any>(mergeFn: (current: T, previous?: T) => T): Effect;
export declare function data(): Effect;
