import { createEffect } from "../lib";
export function select(selector) {
    return createStoreEffect((store, ec) => {
        ec.next(selector ? selector(store.getState()) : store.getState());
    });
}
export function dispatch(action) {
    return createStoreEffect((store, ec) => {
        ec.next(store.dispatch(action));
    });
}
export function createStoreEffect(effect) {
    return createEffect((ec) => {
        const store = ec.context.store;
        if (!store) {
            throw new Error("No Redux store found");
        }
        return effect(store, ec);
    });
}
