"use strict";
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.data = exports.extra = exports.spawn = exports.fork = exports.restart = exports.run = exports.start = exports.call = exports.race = exports.all = exports.emit = exports.on = exports.partial = exports.stale = exports.expiry = exports.cancel = exports.block = exports.debounce = exports.remove = exports.retry = void 0;
var main_1 = require("./main");
function retry(inputOptions, fn) {
    var args = [];
    for (var _i = 2; _i < arguments.length; _i++) {
        args[_i - 2] = arguments[_i];
    }
    var options = inputOptions;
    if (typeof inputOptions !== "object") {
        options = { max: inputOptions };
    }
    if (!options.max) {
        throw new Error("Invalid RetryOptions. 'times' options is required");
    }
    return (function () {
        var i, result, e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    i = 0;
                    _a.label = 1;
                case 1:
                    if (!(i < options.max)) return [3 /*break*/, 8];
                    _a.label = 2;
                case 2:
                    _a.trys.push([2, 4, , 7]);
                    return [4 /*yield*/, fn.apply(void 0, args)];
                case 3:
                    result = _a.sent();
                    return [2 /*return*/, result];
                case 4:
                    e_1 = _a.sent();
                    if (!options.delay) return [3 /*break*/, 6];
                    return [4 /*yield*/, (0, main_1.delay)(options.delay)];
                case 5:
                    _a.sent();
                    _a.label = 6;
                case 6: return [3 /*break*/, 7];
                case 7:
                    i++;
                    return [3 /*break*/, 1];
                case 8: return [2 /*return*/];
            }
        });
    })();
}
exports.retry = retry;
function remove(key) {
    return (0, main_1.createEffect)(function (ec) {
        if (Array.isArray(key)) {
            key.forEach(function (k) { return ec.controller.remove(k); });
        }
        else {
            ec.controller.remove(key);
        }
    });
}
exports.remove = remove;
function debounce(ms) {
    return (0, main_1.createEffect)(function (ec) {
        ec.call(function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: 
                    // cancel previous
                    return [4 /*yield*/, cancel()];
                    case 1:
                        // cancel previous
                        _a.sent();
                        // delay in specified time
                        return [4 /*yield*/, (0, main_1.delay)(ms)];
                    case 2:
                        // delay in specified time
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    });
}
exports.debounce = debounce;
function block(value) {
    if (value === void 0) { value = true; }
    return (0, main_1.createEffect)(function (ec) {
        ec.flow.setBlock(value);
        ec.next();
    });
}
exports.block = block;
function cancel(target) {
    var hasTarget = !!arguments.length;
    return (0, main_1.createEffect)(function (ec) {
        var _a;
        if (hasTarget) {
            // cancel flow by key
            if (typeof target === "function" || typeof target === "string") {
                ec.controller.cancelFlow(target);
            }
            // cancel cancellable object
            else if (typeof target === "object" &&
                typeof target.cancel === "function") {
                target === null || target === void 0 ? void 0 : target.cancel();
            }
            else {
                // throw error ?
            }
        }
        else {
            // cancel previous
            (_a = ec.flow.previous) === null || _a === void 0 ? void 0 : _a.cancel();
        }
        ec.next();
    });
}
exports.cancel = cancel;
function expiry(value) {
    return (0, main_1.createEffect)(function (ec) {
        ec.flow.on("end", function () {
            if (value instanceof Date) {
                ec.flow.setExpiry(value.getTime());
            }
            else {
                ec.flow.setExpiry(Date.now() + value);
            }
        });
        ec.next();
    });
}
exports.expiry = expiry;
function stale(type, key, check) {
    return (0, main_1.createEffect)(function (ec) {
        var _a;
        // stale('when', timeout)
        if (type === "when" && !isNaN(key)) {
            ec.flow.on("end", function () {
                ec.flow.setStale(Date.now() + key);
            });
        }
        else if (type === "when" && key instanceof Date) {
            ec.flow.on("end", function () {
                ec.flow.setStale(key.getTime());
            });
        }
        // stale('when', promise)
        else if (type === "when" && key && typeof key.then === "function") {
            ec.flow.on("end", function () {
                var called = ec.flow.called;
                var onDone = function () {
                    if (called !== ec.flow.called)
                        return;
                    ec.flow.setStale(2);
                };
                if (typeof key.finally === "function") {
                    key.finally(onDone);
                }
                else {
                    key.then(onDone, onDone);
                }
            });
        }
        else {
            var events_1 = type === "flow"
                ? [main_1.FLOW_UPDATE_EVENT]
                : Array.isArray(key)
                    ? key
                    : [key];
            var keys_1 = (_a = (type === "flow"
                ? Array.isArray(key)
                    ? key
                    : [key]
                : undefined)) === null || _a === void 0 ? void 0 : _a.map(main_1.getKey);
            ec.flow.on("end", function () {
                var called;
                (0, main_1.listenerChain)(function (cleanup) { return function (payload) {
                    if (ec.flow.status === "running") {
                        return;
                    }
                    if (ec.flow.called !== called) {
                        cleanup();
                        return;
                    }
                    if (type === "flow") {
                        var flow = payload;
                        if (keys_1 && !keys_1.includes(flow.key))
                            return;
                    }
                    if (check && !check(payload)) {
                        return;
                    }
                    cleanup();
                    ec.flow.setStale(2);
                }; }, function (listener, add) {
                    called = ec.flow.called;
                    add(ec.controller.on(events_1, listener));
                });
            });
        }
        ec.next();
    });
}
exports.stale = stale;
function partial(data, wait) {
    return (0, main_1.createEffect)(function (ec) {
        ec.flow.partial(data, wait || false);
        if (wait) {
            ec.flow.setNext(ec.next);
        }
        else {
            ec.next();
        }
    });
}
exports.partial = partial;
function on(event) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        args[_i - 1] = arguments[_i];
    }
    var hasFlow = args.length > 1;
    return (0, main_1.createEffect)(function (ec) {
        var latest;
        var cancel = (0, main_1.listenerChain)(function (cleanup) { return function (payload) {
            if (!hasFlow) {
                cancel === null || cancel === void 0 ? void 0 : cancel();
                return ec.next(payload);
            }
            latest = (0, main_1.createFlow)({
                controller: ec.controller,
                parent: ec.flow,
                previous: latest,
                key: main_1.NO_KEY,
                fn: args[0],
                onError: ec.fail,
                onEnd: cleanup,
            });
            latest.start.apply(latest, __spreadArray([payload], args.slice(1), false));
        }; }, function (listener, add) {
            add(ec.controller.on(event, listener));
        });
        if (hasFlow) {
            return ec.next({ cancel: cancel });
        }
    });
}
exports.on = on;
function emit(event, payload) {
    return (0, main_1.createEffect)(function (ec) {
        ec.controller.emit(event, payload);
        ec.next();
    });
}
exports.emit = emit;
function all(targets) {
    return handleParallel("all", targets);
}
exports.all = all;
function race(targets) {
    return handleParallel("race", targets);
}
exports.race = race;
function call(fn) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        args[_i - 1] = arguments[_i];
    }
    return (0, main_1.createEffect)(function (ec) {
        ec.call.apply(ec, __spreadArray([fn], args, false));
    });
}
exports.call = call;
function start() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    return (0, main_1.createEffect)(function (ec) {
        runFlow(ec, "start", args);
    });
}
exports.start = start;
function run() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    return (0, main_1.createEffect)(function (ec) {
        runFlow(ec, "execute", args);
    });
}
exports.run = run;
function restart() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    return (0, main_1.createEffect)(function (ec) {
        runFlow(ec, "restart", args);
    });
}
exports.restart = restart;
function fork(flow) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        args[_i - 1] = arguments[_i];
    }
    return (0, main_1.createEffect)(function (ec) {
        var _a = (0, main_1.createFlow)({
            controller: ec.controller,
            parent: ec.flow,
            key: main_1.NO_KEY,
            fn: flow,
        }), cancel = _a.cancel, start = _a.start;
        start.apply(void 0, args);
        return ec.next({ cancel: cancel });
    });
}
exports.fork = fork;
function spawn(flow) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        args[_i - 1] = arguments[_i];
    }
    return (0, main_1.createEffect)(function (ec) {
        var _a = (0, main_1.createFlow)({
            controller: ec.controller,
            key: main_1.NO_KEY,
            fn: flow,
        }), cancel = _a.cancel, start = _a.start;
        start.apply(void 0, args);
        return ec.next({ cancel: cancel });
    });
}
exports.spawn = spawn;
function extra(value) {
    var hasValue = arguments.length;
    return (0, main_1.createEffect)(function (ec) {
        if (hasValue) {
            Object.assign(ec.flow.extra, value);
        }
        else {
            ec.next(ec.flow.extra);
        }
    });
}
exports.extra = extra;
function data() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    return (0, main_1.createEffect)(function (ec) {
        var _a;
        if (!args.length) {
            ec.next((_a = ec.flow.previous) === null || _a === void 0 ? void 0 : _a.data);
        }
        else if (args.length === 1) {
            ec.flow.setMerge(args[0]);
            ec.next();
        }
        else {
            var key = args[0], value = args[1];
            var flow = ec.controller.flow(key);
            if ((flow === null || flow === void 0 ? void 0 : flow.key) === ec.flow.key) {
                throw new Error("Cannot update running flow");
            }
            flow === null || flow === void 0 ? void 0 : flow.update(value);
            ec.next();
        }
    });
}
exports.data = data;
function runFlow(ec, method, args) {
    var _a;
    var result = (_a = ec.controller)[method].apply(_a, args);
    if (method === "execute") {
        return ec.next(result);
    }
    var onUpdate = function () {
        var current = result.current;
        if (current.status === "running") {
            return;
        }
        if (current.status === "faulted") {
            return ec.fail(current.error);
        }
        ec.next(current.data);
    };
    if (result.status !== "running" && result.status !== "idle") {
        return onUpdate();
    }
    var cleanup = ec.controller.on(main_1.FLOW_UPDATE_EVENT, function (x) {
        if (x.key !== result.key)
            return;
        cleanup();
        onUpdate();
    });
    ec.flow.on("end", cleanup);
}
function handleParallel(type, targets) {
    var entries = Object.entries(targets);
    var isArray = Array.isArray(targets);
    return (0, main_1.createEffect)(function (ec) {
        var done = false;
        var count = 0;
        var flows = new Map();
        var results = isArray ? [] : {};
        var cancelOthers = function (current) {
            flows.forEach(function (flow, key) {
                if (key === current)
                    return;
                flow.cancel();
            });
        };
        var onDone = function (key, success, value) {
            if (done)
                return;
            count++;
            if (!success) {
                done = true;
                cancelOthers(key);
                return ec.fail(value);
            }
            results[key] = value;
            if (type === "race") {
                done = true;
                cancelOthers(key);
                if (isArray) {
                    return value;
                }
                return ec.next(results);
            }
            else if (count >= entries.length) {
                done = true;
                ec.next(results);
            }
        };
        entries.forEach(function (_a) {
            var key = _a[0], target = _a[1];
            var fn = function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, target];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            };
            var flow = (0, main_1.createFlow)({
                controller: ec.controller,
                parent: ec.flow,
                key: main_1.NO_KEY,
                fn: fn,
                onSuccess: function (data) {
                    onDone(key, true, data);
                },
                onError: function (error) {
                    onDone(key, false, error);
                },
            });
            flows.set(key, flow);
            flow.start();
        });
    });
}
