"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createStoreEffect = exports.dispatch = exports.select = void 0;
var lib_1 = require("../lib");
function select(selector) {
    return createStoreEffect(function (store, ec) {
        ec.next(selector ? selector(store.getState()) : store.getState());
    });
}
exports.select = select;
function dispatch(action) {
    return createStoreEffect(function (store, ec) {
        ec.next(store.dispatch(action));
    });
}
exports.dispatch = dispatch;
function createStoreEffect(effect) {
    return (0, lib_1.createEffect)(function (ec) {
        var store = ec.context.store;
        if (!store) {
            throw new Error("No Redux store found");
        }
        return effect(store, ec);
    });
}
exports.createStoreEffect = createStoreEffect;
